#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

void cat_file(int fd) {
    // = {0} means fill with zeros. You don't have to do this but it makes
    // things easier to debug.
    char buf[256] = {0};

    // Points to the byte in buf where we are currently writing.
    char * ptr = buf;

    // read returns the number of bytes read on success, 0 on end of file, and
    // -1 on error. We treat errors as the end of the file.
    while (read(fd, ptr, 1) > 0) {
        // Move to the next byte.
        ptr += 1;
    }
    // Null terminate the buffer.
    *ptr = 0;

    // Write the buffer to standard out
    printf("%s\n", buf);
    // Flush standard out (not necessary but nice)
    fflush(stdout);
}

int main(int argc, char* argv[]) {
    int fd = open(argv[1], O_RDONLY);
    cat_file(fd);
}
